import type { AccordionProps } from '../Accordion';
import type { AffixProps } from '../Affix';
import type { BounceProps } from '../Animation/Bounce';
import type { CollapseProps } from '../Animation/Collapse';
import type { FadeProps } from '../Animation/Fade';
import type { SlideProps } from '../Animation/Slide';
import type { TransitionProps } from '../Animation/Transition';
import type { AutoCompleteProps } from '../AutoComplete';
import type { AvatarProps } from '../Avatar';
import type { AvatarGroupProps } from '../AvatarGroup';
import type { BadgeProps } from '../Badge';
import type { BreadcrumbProps } from '../Breadcrumb';
import type { ButtonProps } from '../Button';
import type { ButtonGroupProps } from '../ButtonGroup';
import type { ButtonToolbarProps } from '../ButtonToolbar';
import type { CalendarProps } from '../Calendar';
import type { CarouselProps } from '../Carousel';
import type { CascadeTreeProps } from '../CascadeTree';
import type { CascaderProps } from '../Cascader';
import type { CheckPickerProps } from '../CheckPicker';
import type { CheckTreeProps } from '../CheckTree';
import type { CheckTreePickerProps } from '../CheckTreePicker';
import type { CheckboxProps } from '../Checkbox';
import type { CheckboxGroupProps } from '../CheckboxGroup';
import type { ColProps } from '../Col';
import type { ContainerProps } from '../Container';
import type { ContentProps } from '../Content';
import type { DateInputProps } from '../DateInput';
import type { DatePickerProps } from '../DatePicker';
import type { DateRangeInputProps } from '../DateRangeInput';
import type { DateRangePickerProps } from '../DateRangePicker';
import type { DividerProps } from '../Divider';
import type { DrawerProps } from '../Drawer';
import type { DropdownProps } from '../Dropdown';
import type { FlexboxGridProps } from '../FlexboxGrid';
import type { FooterProps } from '../Footer';
import type { FormProps } from '../Form';
import type { FormControlProps } from '../FormControl';
import type { FormControlLabelProps } from '../FormControlLabel';
import type { FormErrorMessageProps } from '../FormErrorMessage';
import type { FormGroupProps } from '../FormGroup';
import type { FormHelpTextProps } from '../FormHelpText';
import type { GridProps } from '../Grid';
import type { HeaderProps } from '../Header';
import type { HeadingProps } from '../Heading';
import type { HeadingGroupProps } from '../HeadingGroup';
import type { HighlightProps } from '../Highlight';
import type { IconButtonProps } from '../IconButton';
import type { InlineEditProps } from '../InlineEdit';
import type { InputProps } from '../Input';
import type { InputGroupProps } from '../InputGroup';
import type { InputNumberProps } from '../InputNumber';
import type { InputPickerProps } from '../InputPicker';
import type { ListProps } from '../List';
import type { LoaderProps } from '../Loader';
import type { MaskedInputProps } from '../MaskedInput';
import type { MessageProps } from '../Message';
import type { ModalProps } from '../Modal';
import type { MultiCascadeTreeProps } from '../MultiCascadeTree';
import type { MultiCascaderProps } from '../MultiCascader';
import type { NavProps } from '../Nav';
import type { NavbarProps } from '../Navbar';
import type { NotificationProps } from '../Notification';
import type { PaginationProps } from '../Pagination';
import type { PanelProps } from '../Panel';
import type { PanelGroupProps } from '../PanelGroup';
import type { PlaceholderGraphProps } from '../Placeholder/PlaceholderGraph';
import type { PlaceholderGridProps } from '../Placeholder/PlaceholderGrid';
import type { PlaceholderParagraphProps } from '../Placeholder/PlaceholderParagraph';
import type { PopoverProps } from '../Popover';
import type { ProgressCircleProps } from '../Progress/ProgressCircle';
import type { ProgressLineProps } from '../Progress/ProgressLine';
import type { RadioProps } from '../Radio';
import type { RadioGroupProps } from '../RadioGroup';
import type { RadioTileProps } from '../RadioTile';
import type { RadioTileGroupProps } from '../RadioTileGroup';
import type { RangeSliderProps } from '../RangeSlider';
import type { RateProps } from '../Rate';
import type { RowProps } from '../Row';
import type { SafeAnchorProps } from '../SafeAnchor';
import type { SelectPickerProps } from '../SelectPicker';
import type { SidebarProps } from '../Sidebar';
import type { SidenavProps } from '../Sidenav';
import type { SliderProps } from '../Slider';
import type { StackProps } from '../Stack';
import type { StepsProps } from '../Steps';
import type { TableProps } from '../Table';
import type { TabsProps } from '../Tabs';
import type { TagProps } from '../Tag';
import type { TagGroupProps } from '../TagGroup';
import type { TagInputProps } from '../TagInput';
import type { TagPickerProps } from '../TagPicker';
import type { TextProps } from '../Text';
import type { TimePickerProps } from '../TimePicker';
import type { TimeRangePickerProps } from '../TimeRangePicker';
import type { TimelineProps } from '../Timeline';
import type { ToggleProps } from '../Toggle';
import type { TooltipProps } from '../Tooltip';
import type { TreeProps } from '../Tree';
import type { TreePickerProps } from '../TreePicker';
import type { UploaderProps } from '../Uploader';
import type { VisuallyHiddenProps } from '../VisuallyHidden';
import type { WhisperProps } from '../Whisper';
interface ComponentProps<T> {
    defaultProps: Partial<T>;
}
export interface ReactSuiteComponents {
    Accordion: ComponentProps<AccordionProps>;
    Affix: ComponentProps<AffixProps>;
    Bounce: ComponentProps<BounceProps>;
    Collapse: ComponentProps<CollapseProps>;
    Fade: ComponentProps<FadeProps>;
    Slide: ComponentProps<SlideProps>;
    Transition: ComponentProps<TransitionProps>;
    AutoComplete: ComponentProps<AutoCompleteProps>;
    Avatar: ComponentProps<AvatarProps>;
    AvatarGroup: ComponentProps<AvatarGroupProps>;
    Badge: ComponentProps<BadgeProps>;
    Breadcrumb: ComponentProps<BreadcrumbProps>;
    Button: ComponentProps<ButtonProps>;
    ButtonGroup: ComponentProps<ButtonGroupProps>;
    ButtonToolbar: ComponentProps<ButtonToolbarProps>;
    Calendar: ComponentProps<CalendarProps>;
    Carousel: ComponentProps<CarouselProps>;
    CascadeTree: ComponentProps<CascadeTreeProps>;
    Cascader: ComponentProps<CascaderProps>;
    CheckPicker: ComponentProps<CheckPickerProps>;
    CheckTree: ComponentProps<CheckTreeProps>;
    CheckTreePicker: ComponentProps<CheckTreePickerProps>;
    Checkbox: ComponentProps<CheckboxProps>;
    CheckboxGroup: ComponentProps<CheckboxGroupProps>;
    Col: ComponentProps<ColProps>;
    Container: ComponentProps<ContainerProps>;
    Content: ComponentProps<ContentProps>;
    DateInput: ComponentProps<DateInputProps>;
    DatePicker: ComponentProps<DatePickerProps>;
    DateRangeInput: ComponentProps<DateRangeInputProps>;
    DateRangePicker: ComponentProps<DateRangePickerProps>;
    Divider: ComponentProps<DividerProps>;
    Drawer: ComponentProps<DrawerProps>;
    Dropdown: ComponentProps<DropdownProps>;
    FlexboxGrid: ComponentProps<FlexboxGridProps>;
    Footer: ComponentProps<FooterProps>;
    Form: ComponentProps<FormProps>;
    FormControl: ComponentProps<FormControlProps>;
    FormControlLabel: ComponentProps<FormControlLabelProps>;
    FormErrorMessage: ComponentProps<FormErrorMessageProps>;
    FormGroup: ComponentProps<FormGroupProps>;
    FormHelpText: ComponentProps<FormHelpTextProps>;
    Grid: ComponentProps<GridProps>;
    Header: ComponentProps<HeaderProps>;
    Heading: ComponentProps<HeadingProps>;
    HeadingGroup: ComponentProps<HeadingGroupProps>;
    Highlight: ComponentProps<HighlightProps>;
    IconButton: ComponentProps<IconButtonProps>;
    InlineEdit: ComponentProps<InlineEditProps>;
    Input: ComponentProps<InputProps>;
    InputGroup: ComponentProps<InputGroupProps>;
    InputNumber: ComponentProps<InputNumberProps>;
    InputPicker: ComponentProps<InputPickerProps>;
    List: ComponentProps<ListProps>;
    Loader: ComponentProps<LoaderProps>;
    MaskedInput: ComponentProps<MaskedInputProps>;
    Message: ComponentProps<MessageProps>;
    Modal: ComponentProps<ModalProps>;
    MultiCascadeTree: ComponentProps<MultiCascadeTreeProps>;
    MultiCascader: ComponentProps<MultiCascaderProps>;
    Nav: ComponentProps<NavProps>;
    Navbar: ComponentProps<NavbarProps>;
    Notification: ComponentProps<NotificationProps>;
    Pagination: ComponentProps<PaginationProps>;
    Panel: ComponentProps<PanelProps>;
    PanelGroup: ComponentProps<PanelGroupProps>;
    PlaceholderGraph: ComponentProps<PlaceholderGraphProps>;
    PlaceholderGrid: ComponentProps<PlaceholderGridProps>;
    PlaceholderParagraph: ComponentProps<PlaceholderParagraphProps>;
    Popover: ComponentProps<PopoverProps>;
    ProgressCircle: ComponentProps<ProgressCircleProps>;
    ProgressLine: ComponentProps<ProgressLineProps>;
    Radio: ComponentProps<RadioProps>;
    RadioGroup: ComponentProps<RadioGroupProps>;
    RadioTile: ComponentProps<RadioTileProps>;
    RadioTileGroup: ComponentProps<RadioTileGroupProps>;
    RangeSlider: ComponentProps<RangeSliderProps>;
    Rate: ComponentProps<RateProps>;
    Row: ComponentProps<RowProps>;
    SafeAnchor: ComponentProps<SafeAnchorProps>;
    SelectPicker: ComponentProps<SelectPickerProps>;
    Sidebar: ComponentProps<SidebarProps>;
    Sidenav: ComponentProps<SidenavProps>;
    Slider: ComponentProps<SliderProps>;
    Stack: ComponentProps<StackProps>;
    Steps: ComponentProps<StepsProps>;
    Table: ComponentProps<TableProps>;
    Tabs: ComponentProps<TabsProps>;
    Tag: ComponentProps<TagProps>;
    TagGroup: ComponentProps<TagGroupProps>;
    TagInput: ComponentProps<TagInputProps>;
    TagPicker: ComponentProps<TagPickerProps>;
    Text: ComponentProps<TextProps>;
    TimePicker: ComponentProps<TimePickerProps>;
    TimeRangePicker: ComponentProps<TimeRangePickerProps>;
    Timeline: ComponentProps<TimelineProps>;
    Toggle: ComponentProps<ToggleProps>;
    Tooltip: ComponentProps<TooltipProps>;
    Tree: ComponentProps<TreeProps>;
    TreePicker: ComponentProps<TreePickerProps>;
    Uploader: ComponentProps<UploaderProps>;
    VisuallyHidden: ComponentProps<VisuallyHiddenProps>;
    Whisper: ComponentProps<WhisperProps>;
}
export {};
